package com.shigongli.controller;

import com.shigongli.common.BaseController;
import com.shigongli.common.ResponseBean;
import com.shigongli.common.StringUtils;
import com.shigongli.entity.TaHouse;
import com.shigongli.entity.TaPerson;
import com.shigongli.entity.TaSurroundTrack;
import com.shigongli.service.ITaHouseService;
import com.shigongli.service.ITaSurroundTrackService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;


@Api(tags = "周边埋点")
@RestController
@RequestMapping("/")
public class TaSurroundTrackController extends BaseController {

    @Autowired
    ITaSurroundTrackService iTaSurroundTrackService;

    @Autowired
    ITaHouseService iTaHouseService;

    @PostMapping("/ma/surround-track")
    @ApiOperation(value="埋点", notes = "埋点", httpMethod = "POST", response = ResponseBean.class)
    public ResponseBean save(@ApiParam("埋点内容") @RequestBody TaSurroundTrack taSurroundTrack,
                             HttpServletRequest request) throws Exception {
        TaPerson person = getPerson(request);
        if (null == person) {
            throw new Exception("人员验证出错, 请重新登录");
        }

        if (StringUtils.isEmpty(taSurroundTrack.getHouseId())) {
            throw new Exception("房源ID不能为空");
        }

        TaHouse taHouse = iTaHouseService.getById(taSurroundTrack.getHouseId());
        if (null == taHouse) {
            throw new Exception("房源信息错误, 请重试");
        }

        taSurroundTrack.setShopId(taHouse.getShopId());
        taSurroundTrack.setPersonId(person.getPersonId());

        if (iTaSurroundTrackService.save(taSurroundTrack)) {
            return ResponseBean.success(taSurroundTrack);
        } else {
            return ResponseBean.error("埋点失败, 请重试", ResponseBean.ERROR_UNAVAILABLE);
        }
    }
}
