package com.shigongli.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.shigongli.common.StringUtils;
import com.shigongli.constants.StatusConstant;
import com.shigongli.entity.TaMateTag;
import com.shigongli.mapper.TaMateTagMapper;
import com.shigongli.service.ITaMateTagService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 素材标签 服务实现类
 * </p>
 *
 * @author yansen
 * @since 2020-12-11
 */
@Service
public class TaMateTagServiceImpl extends ServiceImpl<TaMateTagMapper, TaMateTag> implements ITaMateTagService {

    @Override
    public List<TaMateTag> getByGroup(String groupId) {
        QueryWrapper<TaMateTag> queryWrapper = new QueryWrapper<TaMateTag>()
                .eq("group_id", groupId)
                .eq("status", StatusConstant.NORMAL)
                .orderByDesc("create_date");
        return list(queryWrapper);
    }

    @Override
    public TaMateTag getByName(String name) {
        QueryWrapper<TaMateTag> queryWrapper = new QueryWrapper<TaMateTag>()
                .eq("name", name)
                .gt("status", StatusConstant.DELETE)
                .last("limit 1");

        return getOne(queryWrapper);
    }

    @Override
    public boolean deleteByGroup(String groupId) {
        if (StringUtils.isEmpty(groupId)) {
            return false;
        }

        UpdateWrapper<TaMateTag> updateWrapper = new UpdateWrapper<TaMateTag>()
                .set("status", StatusConstant.DELETE)
                .eq("group_id", groupId);

        return update(updateWrapper);
    }
}
